Bug 689632

Summary: write access to /dev/input/js*
Product: [Fedora] Fedora Reporter: Sean Middleditch <sean>
Component: systemdAssignee: udev-maint
Status: CLOSED EOL QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: unspecified Docs Contact:
Priority: unspecified    
Version: 19CC: harald, johannbg, jonathan, jsynacek, lnykryn, lpoetter, msekleta, s, systemd-maint, vpavlin, zbyszek
Target Milestone: ---   
Target Release: ---   
Hardware: Unspecified   
OS: Unspecified   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2015-02-17 08:41:42 EST Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:

Description Sean Middleditch 2011-03-21 19:09:19 EDT
When I log in, I am not being given write access to /dev/input/js* (such as an XBox controller using the kernel's xpad driver).

That means I can't use the force-feedback APIs, which require write access to play effects.

I'm not logging in via GDM, but logging in from a console and then using startx.  Not sure if that's related.  (GDM refuses to start for me in Rawhide right now so I can't test that.)
Comment 1 Lennart Poettering 2011-03-31 07:42:32 EDT
Oh, ha, this is without gdm? Not sure we support CK access handling in startx.
Comment 2 Lennart Poettering 2011-03-31 07:43:38 EDT
This bug is not in CK. It is either in udev if the access mode is not the right one which is chosen. Or it might be in startx since that doesn't call CK. Not sure if we care about that though.

Anyway, tentatively reassigned to udev now.
Comment 3 Harald Hoyer 2011-03-31 11:24:56 EDT
$ grep -i joyst /lib/udev/rules.d/70-acl.rules
# joysticks
SUBSYSTEM=="input", ENV{ID_INPUT_JOYSTICK}=="?*", TAG+="udev-acl"

for usb joysticks, this is done automatically with usb_id in
/lib/udev/rules.d/60-persistent-input.rules

You have to manually create a udev rule for your device and set
ENV{ID_INPUT_JOYSTICK}=1

what is the output of:

# for i in /dev/input/js*;do udevadm info --query=all --name=$i;done
Comment 4 Sean Middleditch 2011-03-31 16:05:21 EDT
Lennart, sorry I put it on the wrong component, I wasn't super sure what exactly sets permissions or how/when it does so.  I've been totally lost in how Linux initialization has worked these the last few years since the old init script system was replaced, and there's really no good overview of how all the components work (udev vs ck vs systemd vs whatever else we have now) and it seems like all the components use wildly different configuration file formats, and most of them don't even have man pages.  The documentation situation totally sucks.  :(

If it is startx's fault, what do I need to do to try to fix it?  I can put together a patch if I knew how to even start on one for this problem.  :)

Harald,

$ for i in /dev/input/js*;do udevadm info --query=all --name=$i;done
P: /devices/pci0000:00/0000:00:13.0/usb5/5-1/5-1:1.0/input/input6/js0
N: input/js0
S: input/by-id/usb-©Microsoft_Corporation_Controller_04AC89C-joystick
S: input/by-path/pci-0000:00:13.0-usb-0:1:1.0-joystick
E: UDEV_LOG=3
E: DEVPATH=/devices/pci0000:00/0000:00:13.0/usb5/5-1/5-1:1.0/input/input6/js0
E: MAJOR=13
E: MINOR=0
E: DEVNAME=/dev/input/js0
E: SUBSYSTEM=input
E: ID_INPUT=1
E: ID_INPUT_JOYSTICK=1
E: ID_VENDOR=©Microsoft_Corporation
E: ID_VENDOR_ENC=©Microsoft\x20Corporation
E: ID_VENDOR_ID=045e
E: ID_MODEL=Controller
E: ID_MODEL_ENC=Controller
E: ID_MODEL_ID=028e
E: ID_REVISION=0114
E: ID_SERIAL=©Microsoft_Corporation_Controller_04AC89C
E: ID_SERIAL_SHORT=04AC89C
E: ID_TYPE=generic
E: ID_BUS=usb
E: ID_USB_INTERFACES=:ff5d01:ff5d03:ff5d02:fffd13:
E: ID_USB_INTERFACE_NUM=00
E: ID_USB_DRIVER=xpad
E: ID_PATH=pci-0000:00:13.0-usb-0:1:1.0
E: DEVLINKS=/dev/input/by-id/usb-©Microsoft_Corporation_Controller_04AC89C-joystick /dev/input/by-path/pci-0000:00:13.0-usb-0:1:1.0-joystick
E: TAGS=:udev-acl:
Comment 5 Harald Hoyer 2011-04-01 03:45:18 EDT
ID_INPUT_JOYSTICK=1 ... so you should get ACLs. What is the output of:

$ getfacl /dev/input/by-id/usb-©Microsoft_Corporation_Controller_04AC89C-joystick

logged in as a normal user.
Comment 6 Sean Middleditch 2011-04-04 01:10:50 EDT
elanthis@stargrazer:~$ getfacl /dev/input/by-id/usb-©Microsoft_Corporation_Controller_04AC89C-joystick
getfacl: Removing leading '/' from absolute path names
# file: dev/input/by-id/usb-©Microsoft_Corporation_Controller_04AC89C-joystick
# owner: root
# group: root
user::rw-
group::r--
other::r--

Again, this is with logging on via a getty and then running startx to get into XFCE.  I'm installing GDM again to see if it can actually log me in without crashing X repeatedly like it has been for the last month, so we can see if that makes a difference.
Comment 7 Harald Hoyer 2011-04-04 08:05:46 EDT
you should get the ACLs via getty also, IIRC
Comment 8 Fedora Admin XMLRPC Client 2011-10-20 12:07:53 EDT
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.
Comment 9 Fedora Admin XMLRPC Client 2011-10-20 12:09:53 EDT
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.
Comment 10 Fedora Admin XMLRPC Client 2011-10-20 12:12:22 EDT
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.
Comment 11 Fedora Admin XMLRPC Client 2011-10-20 12:16:45 EDT
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.
Comment 12 Harald Hoyer 2011-10-21 05:44:01 EDT
still an issue??
Comment 13 Fedora End Of Life 2013-04-03 13:55:33 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 19 development cycle.
Changing version to '19'.

(As we did not run this process for some time, it could affect also pre-Fedora 19 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 19 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora19
Comment 14 Fedora End Of Life 2015-01-09 11:37:08 EST
This message is a notice that Fedora 19 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 19. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained. Approximately 4 (four) weeks from now this bug will
be closed as EOL if it remains open with a Fedora 'version' of '19'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 19 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 15 Fedora End Of Life 2015-02-17 08:41:42 EST
Fedora 19 changed to end-of-life (EOL) status on 2015-01-06. Fedora 19 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.